//          Copyright Carl Philipp Reh 2009 - 2021.
// Distributed under the Boost Software License, Version 1.0.
//    (See accompanying file LICENSE_1_0.txt or copy at
//          http://www.boost.org/LICENSE_1_0.txt)

#ifndef FCPPT_ITERATOR_RANGE_IMPL_HPP_INCLUDED
#define FCPPT_ITERATOR_RANGE_IMPL_HPP_INCLUDED

#include <fcppt/iterator/range_decl.hpp> // IWYU pragma: export
#include <fcppt/config/external_begin.hpp>
#include <utility>
#include <fcppt/config/external_end.hpp>

template <typename Iterator>
// NOLINTNEXTLINE(bugprone-easily-swappable-parameters)
fcppt::iterator::range<Iterator>::range(Iterator &&_begin, Iterator &&_end)
    : begin_{std::move(_begin)}, end_{std::move(_end)}
{
}

template <typename Iterator>
// NOLINTNEXTLINE(bugprone-easily-swappable-parameters)
fcppt::iterator::range<Iterator>::range(Iterator const &_begin, Iterator const &_end)
    : begin_{_begin}, end_{_end}
{
}

template <typename Iterator>
Iterator fcppt::iterator::range<Iterator>::begin() const
{
  return this->begin_;
}

template <typename Iterator>
Iterator fcppt::iterator::range<Iterator>::end() const
{
  return this->end_;
}

#endif
